﻿@Echo off
SET LogPath=C:\OEM\AcerLogs\%1.log
ECHO.>>%LogPath%
ECHO %DATE% %TIME%[Log START]  ============ %~dpnx0 ============ >> %LogPath%
Pushd "%~dp0"
SETLOCAL ENABLEDELAYEDEXPANSION

set Balanced_GUID=381b4222-f694-41f0-9685-ff5bb260df2e
SET HighPer_GUID=8c5e7fda-e8bf-4a96-9a85-a6e23a8c635c
SET FindingPath=C:\OEM\Preload\Command\PAP\PAP*.INI
if not exist C:\OEM\Preload\Command\PAP\PAP*.INI (
	ECHO %DATE% %TIME%[Log TRACE]  PAP*.ini not found, SET FindingPath=C:\OEM\Preload\Command\POP*.INI >>%LogPath%
	SET FindingPath=C:\OEM\Preload\Command\POP*.INI
)
ECHO %DATE% %TIME%[Log TRACE]  FindingPath is [%FindingPath%] >>%LogPath%
ECHO %DATE% %TIME%[Log TRACE]  call :%1 >>%LogPath%
call :%1

SETLOCAL DISABLEDELAYEDEXPANSION
popd
ECHO %DATE% %TIME%[Log LEAVE]  ============ %~dpnx0 ============ >> %LogPath%
ECHO.>>%LogPath%
exit /b 0




:FirstBoot
ECHO %DATE% %TIME%[Log TRACE]  call :ActivePowerPlan>>%LogPath%
call :ActivePowerPlan
exit /b 0


:UserAlaunch
:::: 	Set power management setting version to tag
echo Power_Management_Setting_v1.0 > c:\oem\preload\PowerManagementSetting.tag
:::: 	Checking LOB by PAP*.ini
SET LOBType=DTSKU
find /i "Product=NB" %FindingPath% >>%LogPath% 2>&1 && SET LOBType=NBSKU
:::: 	Checking Product Type by PAP*.ini
SET ProductType=Normal
find /i "Product Type=Tablet" %FindingPath% >>%LogPath% 2>&1 && SET ProductType=Tablet

SET WithLightSensor=FALSE
PowerSettingUtility_%processor_architecture%.exe -CheckLightSensor
if %errorlevel% neq 0 SET WithLightSensor=TRUE
ECHO %DATE% %TIME%[Log TRACE]  WithLightSensor is [%WithLightSensor%] >>%LogPath%

::::	Checking Connected Standby sku
::::	2016/8/29
::::		Revised the CS sku detection rule
::::		Enable High Performance will let CS sku of power plan amount change to 2
SET CS_SKU=FALSE
SET Count=0
ECHO %DATE% %TIME%[Log TRACE]  powercfg /L >>%LogPath% 2>&1
powercfg /L >>%LogPath% 2>&1
for /f "skip=3 delims=" %%P in ('powercfg /L') do Set /A Count+=1
IF %Count% NEQ 3 SET CS_SKU=TRUE
ECHO %DATE% %TIME%[Log TRACE]  CS_SKU is [%CS_SKU%] >>%LogPath%

::::	Checking if Storage greater 32G
if exist c:\oem\preload\StorageSmallThen32G.tag del /f /q c:\oem\preload\StorageSmallThen32G.tag
ECHO %DATE% %TIME%[Log TRACE]  cscript /nologo _CreateSmallStorageTag.vbs >>%LogPath% 2>&1
cscript /nologo _CreateSmallStorageTag.vbs >>%LogPath% 2>&1

if /i "%LOBType%" EQU "NBSKU" (
	ECHO !DATE! !TIME![Log TRACE]  NB image, call :NB >>%LogPath%
	call :NB
)
if /i "%LOBType%" EQU "DTSKU" (
	ECHO !DATE! !TIME![Log TRACE]  DT image, call :DT >>%LogPath%
	call :DT
)
::::	2017/3/16
::::		Cloud image will not exist FirstBoot phase, 
::::		discard the DisableS3_LidCloseNoAction feature and active power plan on UserAlaunch
ECHO %DATE% %TIME%[Log TRACE]  reg query HKLM\SOFTWARE\OEM\Metadata /v CloudSku >>%LogPath% 2>&1
reg query HKLM\SOFTWARE\OEM\Metadata /v CloudSku >>%LogPath% 2>&1
for /f "tokens=3 delims= " %%B in ('reg query HKLM\SOFTWARE\OEM\Metadata /v CloudSku ^| find /i "CloudSku"') do set IsCloud=%%B
ECHO %DATE% %TIME%[Log TRACE]  IsCloud=[%IsCloud%]>>%LogPath%
if /i "%IsCloud%" EQU "TRUE" (
	ECHO %DATE% %TIME%[Log TRACE]  call :ActivePowerPlan>>%LogPath%
	call :ActivePowerPlan
)
exit /b 0



:DT
SET ePMSpec=%CD%\ePMSpec_DT.ini
ECHO %DATE% %TIME%[Log TRACE]  call Sub_PowerCFG_DT.cmd >>%LogPath%
call Sub_PowerCFG_DT.cmd >>%LogPath% 2>&1
ECHO %DATE% %TIME%[Log TRACE]  %~dp0WriteCurrentPowerPlanToDefault_%Processor_Architecture%.exe >>%LogPath%
%~dp0WriteCurrentPowerPlanToDefault_%Processor_Architecture%.exe >>%LogPath% 2>&1
exit /b 0



:NB
SET ePMSpec=%CD%\ePMSpec_NB.ini
::::	Update spec for Tablet
if /i "%ProductType%" equ "Tablet" (
	ECHO !DATE! !TIME![Log TRACE]  powershell -ExecutionPolicy ByPass -command ".\ReplaceSpec.ps1 \"%ePMSpec%\" \"0902=100 80 100 40 100 10\" \"0902=100 30 100 30 100 30\"">> %LogPath% 2>&1
	powershell -ExecutionPolicy ByPass -command ".\ReplaceSpec.ps1 \"%ePMSpec%\" \"0902=100 80 100 40 100 10\" \"0902=100 30 100 30 100 30\"">> %LogPath% 2>&1
	ECHO !DATE! !TIME![Log TRACE]  powershell -ExecutionPolicy ByPass -command ".\ReplaceSpec.ps1 \"%ePMSpec%\" \"0903=0 480 0 300 0 180\" \"0903=180 180 180 180 180 180\"">> %LogPath% 2>&1
	powershell -ExecutionPolicy ByPass -command ".\ReplaceSpec.ps1 \"%ePMSpec%\" \"0903=0 480 0 300 0 180\" \"0903=180 180 180 180 180 180\"">> %LogPath% 2>&1
)

:::: 	Update spec for W/ Light Sensor
if /i "%WithLightSensor%" equ "TRUE" (
	ECHO !DATE! !TIME![Log TRACE]  powershell -ExecutionPolicy ByPass -command ".\ReplaceSpec.ps1 \"%ePMSpec%\" \"0902=100 80 100 40 100 10\" \"0902=100 20 100 20 100 20\"">> %LogPath% 2>&1
	powershell -ExecutionPolicy ByPass -command ".\ReplaceSpec.ps1 \"%ePMSpec%\" \"0902=100 80 100 40 100 10\" \"0902=100 20 100 20 100 20\"">> %LogPath% 2>&1
)


::::	Hibernate status setting
if exist c:\oem\preload\StorageSmallThen32G.tag (
	if /i "%CS_SKU%" equ "FALSE" (
		ECHO !DATE! !TIME![Log TRACE]  powershell -ExecutionPolicy ByPass -command ".\ReplaceSpec.ps1 \"%ePMSpec%\" \"1106=2 2 2 2 2 2\" \"1106=3 1 3 1 3 1\"">> %LogPath% 2>&1
		powershell -ExecutionPolicy ByPass -command ".\ReplaceSpec.ps1 \"%ePMSpec%\" \"1106=2 2 2 2 2 2\" \"1106=3 1 3 1 3 1\"">> %LogPath% 2>&1
		REM Powercfg /H OFF
		ECHO !DATE! !TIME![Log TRACE]  Powercfg /A >>%LogPath% 2>&1
		Powercfg /A >>%LogPath% 2>&1
	) else (
		ECHO !DATE! !TIME![Log TRACE]  POWERCFG /h /type full >>%LogPath%
		POWERCFG /h /type full
		ECHO !DATE! !TIME![Log TRACE]  Powercfg /A >>%LogPath% 2>&1
		Powercfg /A >>%LogPath% 2>&1
	)
) ELSE (
	ECHO !DATE! !TIME![Log TRACE]  Powercfg /H ON >>%LogPath%
	Powercfg /H ON
	ECHO !DATE! !TIME![Log TRACE]  Powercfg /A >>%LogPath% 2>&1
	Powercfg /A >>%LogPath% 2>&1
)


ECHO %DATE% %TIME%[Log TRACE]  call Sub_PowerCFG_NB.cmd >>%LogPath%
call Sub_PowerCFG_NB.cmd >>%LogPath% 2>&1

ECHO %DATE% %TIME%[Log TRACE]  %~dp0WriteCurrentPowerPlanToDefault_%Processor_Architecture%.exe >>%LogPath%
%~dp0WriteCurrentPowerPlanToDefault_%Processor_Architecture%.exe >>%LogPath% 2>&1
exit /b 0



:ActivePowerPlan
SET PowerPlan=HighPerformance
::::	NB all is Balanced
ECHO %DATE% %TIME%[Log TRACE]  find /i "Product=NB" %FindingPath% >>%LogPath% 2>&1
find /i "Product=NB" %FindingPath% >>%LogPath% 2>&1 && SET PowerPlan=Balanced
::::	DT Commercial is Balanced
ECHO %DATE% %TIME%[Log TRACE]  find /i "Model Type Name=Veriton" %FindingPath% >>%LogPath% 2>&1
find /i "Model Type Name=Veriton" %FindingPath% >>%LogPath% 2>&1 && SET PowerPlan=Balanced
ECHO %DATE% %TIME%[Log TRACE]  find /i "Model Type Name=Extensa" %FindingPath% >>%LogPath% 2>&1
find /i "Model Type Name=Extensa" %FindingPath% >>%LogPath% 2>&1 && SET PowerPlan=Balanced
ECHO %DATE% %TIME%[Log TRACE]  find /i "Brand=Founder" %FindingPath% >>%LogPath% 2>&1
find /i "Brand=Founder" %FindingPath% >>%LogPath% 2>&1 && SET PowerPlan=Balanced
ECHO %DATE% %TIME%[Log TRACE]  if exist C:\OEM\Preload\ResourceCD\*.* then SET PowerPlan=Balanced >>%LogPath% 2>&1
if exist C:\OEM\Preload\ResourceCD\*.* SET PowerPlan=Balanced

::::	2017/2/21
::::	new feature into PredatorSense(RC 2.01.2000 for Sienta/Sienna) and also future build for Falcon.
::::	PredatorSense makes default power plan for AC mode in High performance, 
::::	and DC mode in Balanced. And record user’s power plan for both AC/DC mode, 
::::	apply user’s power plan when AC/DC changed. This feature is no UI, work in background.
::::	To prevent power plan confliction, PredatorSense will create a tag for power plan setting module.
::::	Once power plan setting module find the tag, please don’t active plan during OOBE.
::::	Tag path: C:\OEM\Preload\NoActivatePowerPlan.tag

if not exist C:\OEM\Preload\NoActivatePowerPlan.tag (
	ECHO %DATE% %TIME%[Log TRACE]  C:\OEM\Preload\NoActivatePowerPlan.tag not found, continue... >>%LogPath%
	if /i "%PowerPlan%" equ "Balanced" (
		ECHO %DATE% %TIME%[Log TRACE]  SET Default Power Plan as Balanced, POWERCFG -SETACTIVE %Balanced_GUID% >>%LogPath%
		POWERCFG -SETACTIVE %Balanced_GUID% >>%LogPath% 2>&1
	) else (
		ECHO %DATE% %TIME%[Log TRACE]  SET Default Power Plan as High Performance, POWERCFG -SETACTIVE %HighPer_GUID% >>%LogPath%
		POWERCFG -SETACTIVE %HighPer_GUID% >>%LogPath% 2>&1
	)
) else (
	ECHO %DATE% %TIME%[Log TRACE]  C:\OEM\Preload\NoActivatePowerPlan.tag found, do not active any power plan. >>%LogPath%
)
exit /b 0